unit FreeOTFEExplorerfrmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, SDUFileIterator_U,
  SDUForms,
  SDUGeneral,
  SDFilesystemCtrls,
  SDFilesystem,
  SDFilesystem_Local,
  SDFilesystem_FAT,
  SDPartitionImage,
  SDPartitionImage_File,
  SDPartitionImage_FreeOTFE,
  SDUComCtrls, ImgList, Menus, Buttons, ExtCtrls, SDUDialogs, ActnList,
  OTFE_U, OTFEFreeOTFEBase_U, OTFEFreeOTFEDLL_U;

type         
  TfrmFreeOTFEExplorerMain = class(TSDUForm)
    SDFilesystemTreeView1: TSDFilesystemTreeView;
    SDFilesystemListView1: TSDFilesystemListView;
    MainMenu1: TMainMenu;
    View1: TMenuItem;
    oolbar1: TMenuItem;
    mnuStatusBar: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    mnuListStyleSmallIcons: TMenuItem;
    mnuListStyleIcons: TMenuItem;
    mnuListStyleList: TMenuItem;
    mnuListStyleDetails: TMenuItem;
    StatusBar: TStatusBar;
    pnlAddressBar: TPanel;
    lblFolder: TLabel;
    edPath: TEdit;
    pbGo: TBitBtn;
    Splitter1: TSplitter;
    ools1: TMenuItem;
    mnuShowBootSector: TMenuItem;
    pmTreeView: TPopupMenu;
    pmListView: TPopupMenu;
    mnuTreeExpand: TMenuItem;
    mnuExploreView: TMenuItem;
    mnuExtract: TMenuItem;
    Edit1: TMenuItem;
    mntSelectAll: TMenuItem;
    File1: TMenuItem;
    mntOpenImageFile: TMenuItem;
    mnuAddressBar: TMenuItem;
    Help1: TMenuItem;
    mntAbout: TMenuItem;
    mnuCheckFilesystem: TMenuItem;
    SDUOpenDialog_Mount: TSDUOpenDialog;
    ImageList_Small: TImageList;
    mnuViewStore: TMenuItem;
    mnuViewStoreFile: TMenuItem;
    mnuViewStoreDir: TMenuItem;
    mnuViewDelete: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    mnuViewProperties: TMenuItem;
    mnuViewCreateSubDir: TMenuItem;
    ActionList1: TActionList;
    actRefresh: TAction;
    Refresh1: TMenuItem;
    mnuTreeCollapse: TMenuItem;
    SDUOpenDialog_Store: TSDUOpenDialog;
    SDUSaveDialog_Extract: TSDUSaveDialog;
    OTFEFreeOTFEDLL1: TOTFEFreeOTFEDLL;
    actFreeOTFEMountFile: TAction;
    miFreeOTFEMountFile: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure mnuListStyle(Sender: TObject);
    procedure mnuStatusBarClick(Sender: TObject);
    procedure pbGoClick(Sender: TObject);
    procedure mnuShowBootSectorClick(Sender: TObject);
    procedure edPathKeyPress(Sender: TObject; var Key: Char);
    procedure mnuTreeExpandClick(Sender: TObject);
    procedure mnuExploreViewClick(Sender: TObject);
    procedure pmViewPopup(Sender: TObject);
    procedure mnuExtractClick(Sender: TObject);
    procedure mntSelectAllClick(Sender: TObject);
    procedure mntOpenImageFileClick(Sender: TObject);
    procedure mnuAddressBarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mntAboutClick(Sender: TObject);
    procedure mnuCheckFilesystemClick(Sender: TObject);
    procedure SDFilesystemListView1SelectItem(Sender: TObject;
      Item: TListItem; Selected: Boolean);
    procedure SDFilesystemTreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure FormResize(Sender: TObject);
    procedure StatusBarDrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure mnuViewStoreFileClick(Sender: TObject);
    procedure mnuViewStoreDirClick(Sender: TObject);
    procedure mnuViewDeleteClick(Sender: TObject);
    procedure mnuViewCreateSubDirClick(Sender: TObject);
    procedure actRefreshExecute(Sender: TObject);
    procedure mnuTreeCollapseClick(Sender: TObject);
    procedure actFreeOTFEMountFileExecute(Sender: TObject);
  private
    PartitionImage: TSDPartitionImage;
    Filesystem: TSDFilesystem_FAT;
  protected
    function  ExtractFile(srcFile: string; destFile: string): boolean;
    function  ExtractDir(srcDir: string; destDir: string): boolean;

    procedure SetTitleCaption(filename: string);

    procedure SetStatusMsg(); overload;
    procedure SetStatusMsg(msg: string); overload;
    function  DefaultStatusMsg(): string;
    function  SelectedItemsStatusMsg(): string;
    procedure SizeStatusBar();

    procedure CloseAnyMounted();
    procedure MountImageFile(filename: string; mountAsFreeOTFE: boolean);

    function  CreateSubDir(path: WideString; newDirName: WideString): boolean;
    function  StoreFile(path: WideString; fileToStore: string): boolean;
    function  StoreDir(path: WideString; dirToStore: string): boolean;

    procedure PromptForFileAndImport(importToPath: WideString);
    procedure PromptForDirAndImport(importToPath: WideString);

  public
    procedure SetupControls();
    procedure EnableDisableControls();
  end;

var
  frmFreeOTFEExplorerMain: TfrmFreeOTFEExplorerMain;

implementation

{$R *.dfm}

uses
// Turn off useless hints about FileCtrl.pas being platform specific
{$WARN SYMBOL_PLATFORM OFF}
{$WARN UNIT_PLATFORM OFF}
  FileCtrl,
{$WARN UNIT_PLATFORM ON}
{$WARN SYMBOL_PLATFORM ON}
  AppGlobals,
  SDUGraphics,
  SDUi18n,
  SDUSysUtils,
  SDUAboutDlg,
  FATBootSectorPropertiesDlg,
  NewDirDlg;

{$IFDEF _NEVER_DEFINED}
// This is just a dummy const to fool dxGetText when extracting message
// information
// This const is never used; it's #ifdef'd out - SDUCRLF in the code refers to
// picks up SDUGeneral.SDUCRLF
const
  SDUCRLF = ''#13#10;
{$ENDIF}

const
  FREEOTFE_URL = 'http://www.FreeOTFE.org/';

resourcestring
  FOTFE_EXPL_DESCRIPTION  = 'An explorer-type application to allow access to FreeOTFE volumes, without requiring administrator rights to install any drivers';


const
  STATUSBAR_PANEL_STATUS        = 0;
  STATUSBAR_PANEL_SELECTEDITEMS = 1;
  STATUSBAR_PANEL_LOCATION      = 2;

  // These icon indexes must match those in ImageList_Small
  IMGLIST_IDX_FREEOTFE = 0;

procedure TfrmFreeOTFEExplorerMain.SetupControls();
begin
  SDFilesystemListView1.Filesystem := Filesystem;
  SDFilesystemListView1.Initialize();

  SDFilesystemTreeView1.Filesystem := Filesystem;
  SDFilesystemTreeView1.Initialize();

  // Expand out the root node
  if (SDFilesystemTreeView1.GoToPath(PATH_SEPARATOR, FALSE) <> nil) then
    begin
    SDFilesystemTreeView1.Selected.Expand(FALSE);
    end;

  SDFilesystemTreeView1.SetFocus();

  SetStatusMsg();

  EnableDisableControls();
end;

procedure TfrmFreeOTFEExplorerMain.FormCreate(Sender: TObject);
var
  goIcon: TIcon;
  goBitmap: TBitmap;
  sysMagGlassIcon: TIcon;
begin
  PartitionImage := nil;
  Filesystem     := nil;

  mnuListStyleSmallIcons.Tag := ord(vsSmallIcon);
  mnuListStyleIcons.Tag      := ord(vsIcon);
  mnuListStyleList.Tag       := ord(vsList);
  mnuListStyleDetails.Tag    := ord(vsReport);

  SDUClearPanel(pnlAddressBar);


  // Add standard Windows "Go" icon to "Go" button
  goIcon := TIcon.Create();
  goBitmap:= TBitmap.Create();
  try
    if SDULoadDLLIcon(
                      DLL_SHELL32,
                      TRUE,
                      DLL_SHELL32_GO_ICON,
                      goIcon
                     ) then
      begin
      // Must specify 16x16 explicitly as the icon loaded is always 32x32
      SDUConvertIconToBitmap(goIcon, 16, 16, goBitmap, nil);
      pbGO.Glyph.Assign(goBitmap);
      end;

  finally
    goBitmap.Free();
    goIcon.Free();
  end;

  // Overlay system standard magnifying glass icon on top of main icon, if
  // possible
  sysMagGlassIcon := TIcon.Create();
  try
    if SDULoadDLLIcon(
                      DLL_SHELL32,
                      FALSE,
                      DLL_SHELL32_MAGNIFYING_GLASS,
                      sysMagGlassIcon
                     ) then
      begin
      SDUOverlayIcon(Application.Icon, sysMagGlassIcon);
      end;

  finally
    sysMagGlassIcon.Free();
  end;

  mnuStatusBar.Checked := TRUE;
  mnuListStyleDetails.Checked := TRUE;
  mnuAddressBar.checked := TRUE;

  OTFEFreeOTFEDLL1.ExeDir := ExtractFilePath(Application.ExeName);

end;

procedure TfrmFreeOTFEExplorerMain.mnuListStyle(Sender: TObject);
begin
  SDFilesystemListView1.ViewStyle := TViewStyle(TMenuItem(Sender).Tag);

end;

procedure TfrmFreeOTFEExplorerMain.mnuStatusBarClick(Sender: TObject);
begin
  EnableDisableControls();
end;

procedure TfrmFreeOTFEExplorerMain.pbGoClick(Sender: TObject);
begin
  if (SDFilesystemTreeView1.GoToPath(edPath.text, FALSE) = nil) then
    begin
    SDUMessageDlg(SDUParamSubstitute(
                                     _('Path not found:'+SDUCRLF+
                                     SDUCRLF+
                                     '%1'),
                                     [edPath.text]
                                    ), mtError);
    end;

end;


procedure TfrmFreeOTFEExplorerMain.mnuShowBootSectorClick(Sender: TObject);
var
  dlg: TFATBootSectorPropertiesDialog;
begin
  dlg:= TFATBootSectorPropertiesDialog.Create(self);
  try
    dlg.Filesystem := TSDFilesystem_FAT(Filesystem);
    dlg.ShowModal();
  finally
    dlg.Free();
  end;

end;

procedure TfrmFreeOTFEExplorerMain.edPathKeyPress(Sender: TObject; var Key: Char);
begin
  // <ENTER> is the same as pressing the "Go" button
  if (Key = #13) then
    begin
    pbGoClick(nil);
    end;

end;

procedure TfrmFreeOTFEExplorerMain.mnuTreeCollapseClick(Sender: TObject);
begin
  SDFilesystemTreeView1.Selected.Collapse(FALSE);
end;

procedure TfrmFreeOTFEExplorerMain.mnuTreeExpandClick(Sender: TObject);
begin
  SDFilesystemTreeView1.Selected.Expand(FALSE);
end;

procedure TfrmFreeOTFEExplorerMain.mnuExploreViewClick(Sender: TObject);
var
  i: integer;
begin
  for i:=0 to (SDFilesystemListView1.Items.count - 1) do
    begin
    if SDFilesystemListView1.Items[i].Selected then
      begin
      SDFilesystemTreeView1.GoToPath(
                                   IncludeTrailingPathDelimiter(SDFilesystemListView1.Path)+SDFilesystemListView1.DirItem[i].Filename,
                                   TRUE
                                  );
      break;
      end;
    end;
end;

procedure TfrmFreeOTFEExplorerMain.pmViewPopup(Sender: TObject);
begin
  EnableDisableControls();
end;

function TfrmFreeOTFEExplorerMain.ExtractFile(srcFile: string; destFile: string): boolean;
var
  retval: boolean;
begin
  SetStatusMsg(SDUParamSubstitute(_('Extracting: %1'), [srcFile]));
  retval := Filesystem.ExtractFile(srcFile, destFile);
  if not(retval) then
    begin
    SDUMessageDlg(
                  _('Unable to extract file:')+SDUCRLF+
                  SDUCRLF+
                  srcFile,
                  mtError
                 );
    end;

  Result := retval;
end;

function TfrmFreeOTFEExplorerMain.ExtractDir(srcDir: string; destDir: string): boolean;
var
  dirContent: TSDDirItemList;
  i: integer;
  retval: boolean;
begin
  retval:= TRUE;

  dirContent:= TSDDirItemList.Create();
  try
    SetStatusMsg(SDUParamSubstitute(_('Extracting: %1'), [srcDir]));

    if not(Filesystem.LoadContentsFromDisk(srcDir, dirContent)) then
      begin
      retval := FALSE;
      SDUMessageDlg(
                    _('Unable to get directory listing for:')+SDUCRLF+
                    SDUCRLF+
                    srcDir,
                    mtError
                   );
      end
    else
      begin
      try
        mkdir(destDir);
      except
        // Swallow any exception; assume the directory already existed
      end;

      for i:=0 to (dirContent.count - 1) do
        begin
        if dirContent[i].IsFile then
          begin
          retval := ExtractFile(
                                IncludeTrailingPathDelimiter(srcDir)+dirContent[i].Filename,
                                IncludeTrailingPathDelimiter(destDir)+dirContent[i].Filename
                               );
          end
        else if (
                 dirContent[i].IsDirectory and
                 (dirContent[i].Filename <> DIR_CURRENT_DIR) and
                 (dirContent[i].Filename <> DIR_PARENT_DIR)
                ) then
          begin
          retval := ExtractDir(
                               IncludeTrailingPathDelimiter(srcDir)+dirContent[i].Filename,
                               IncludeTrailingPathDelimiter(destDir)+dirContent[i].Filename
                              );
          end;

        if not(retval) then
          begin
          break;
          end;
        end;

      end;

  finally
    dirContent.Free();
  end;

  Result := retval;
end;


procedure TfrmFreeOTFEExplorerMain.mnuExtractClick(Sender: TObject);
var
  i: integer;
  extractToDir: string;
  extractFromPath: string;
  allOK: boolean;
begin
  if SDUSelectDirectory(
                     self.Handle,
                     _('Select location to extract to:'),
                     '',
                     extractToDir,
                     BIF_USENEWUI
                    ) then
    begin
    allOK := TRUE;

    SetStatusMsg(SDUParamSubstitute(_('Extracting to: %1'), [extractToDir]));

    for i:=0 to (SDFilesystemListView1.Items.count - 1) do
      begin
      if SDFilesystemListView1.Items[i].Selected then
        begin
        extractFromPath := IncludeTrailingPathDelimiter(SDFilesystemListView1.Path)+SDFilesystemListView1.DirItem[i].Filename;

        if SDFilesystemListView1.DirItem[i].IsFile then
          begin
          if not(ExtractFile(
                             extractFromPath,
                             IncludeTrailingPathDelimiter(extractToDir)+SDFilesystemListView1.DirItem[i].Filename
                            )) then
            begin
            allOK := FALSE;
            end;
          end
        else if (
                 SDFilesystemListView1.DirItem[i].IsDirectory and
                 (SDFilesystemListView1.DirItem[i].Filename <> DIR_CURRENT_DIR) and
                 (SDFilesystemListView1.DirItem[i].Filename <> DIR_PARENT_DIR)
                ) then
          begin
          if not(ExtractDir(
                            extractFromPath,
                            IncludeTrailingPathDelimiter(extractToDir)+SDFilesystemListView1.DirItem[i].Filename
                           )) then
            begin
            allOK := FALSE;
            end;
          end;
          
        end;
      end;

    SetStatusMsg('');
    
    if allOK then
      begin
      SDUMessageDlg(_('Extraction completed successfully.'), mtInformation);
      end;
      
    end;

end;

procedure TfrmFreeOTFEExplorerMain.EnableDisableControls();
var
  mountedFilesystem: boolean;
  mountedWritable: boolean;
begin
  mountedFilesystem := FALSE;
  mountedWritable := FALSE;
  if (Filesystem <> nil) then
    begin
    mountedFilesystem := Filesystem.Mounted;
    mountedWritable := (
                        mountedFilesystem and
                        not(Filesystem.Readonly)
                       );
    end;

  mnuTreeExpand.Visible := (
                            (SDFilesystemTreeView1.SelectionCount = 1) and
                            not(SDFilesystemTreeView1.Selected.Expanded)
                           );
  mnuTreeCollapse.Visible := (
                              (SDFilesystemTreeView1.SelectionCount = 1) and
                              SDFilesystemTreeView1.Selected.Expanded
                             );

  SDUEnableControl(
                   mnuExploreView,
                   (
                    (SDFilesystemListView1.SelCount = 1) and
                    SDFilesystemListView1.DirItem[SDFilesystemListView1.SelectedIdx].IsDirectory
                   )
                  );
  SDUEnableControl(mnuExtract, (SDFilesystemListView1.SelCount > 0));

  SDUEnableControl(mnuShowBootSector, mountedFilesystem);

  SDUEnableControl(mnuCheckFilesystem, mountedFilesystem);

  SDUEnableControl(mnuViewStore, mountedWritable);
  SDUEnableControl(mnuViewCreateSubDir, mountedWritable);
  SDUEnableControl(mnuViewDelete, mountedWritable);

  SDUEnableControl(pbGo, mountedFilesystem);
  SDUEnableControl(edPath, mountedFilesystem);

  StatusBar.Visible := mnuStatusBar.checked;
  pnlAddressBar.Visible := mnuAddressBar.checked;
end;

procedure TfrmFreeOTFEExplorerMain.SetTitleCaption(filename: string);
begin
  if (filename = '') then
    begin
    self.Caption := Application.Title;
    end
  else
    begin
    self.Caption := Application.Title + ' - ' + ExtractFilename(filename);
    end;

end;

procedure TfrmFreeOTFEExplorerMain.SetStatusMsg();
begin
  SetStatusMsg('');
end;

procedure TfrmFreeOTFEExplorerMain.SetStatusMsg(msg: string);
begin
  if (msg = '') then
    begin
    msg := DefaultStatusMsg();

    // If setting to default status message, update the selected items panel
    if (Filesystem = nil) then
      begin
      StatusBar.Panels[STATUSBAR_PANEL_SELECTEDITEMS].Text := '';
      end
    else
      begin
      StatusBar.Panels[STATUSBAR_PANEL_SELECTEDITEMS].Text := SelectedItemsStatusMsg();
      end;

    StatusBar.Panels[STATUSBAR_PANEL_LOCATION].Text := '';
    if (Filesystem <> nil) then
      begin
      StatusBar.Panels[STATUSBAR_PANEL_LOCATION].Text := _('Secure volume');
      end;
    end;

  SizeStatusBar();
  StatusBar.Panels[STATUSBAR_PANEL_STATUS].Text := msg;
end;


procedure TfrmFreeOTFEExplorerMain.SizeStatusBar();
begin
  // These values approximate the sizes of the panels Windows Explorer uses
  // (under Windows XP, with no themes, at any rate)
  StatusBar.Panels[STATUSBAR_PANEL_SELECTEDITEMS].Width :=  80;
  StatusBar.Panels[STATUSBAR_PANEL_LOCATION].Width      := 165;

  StatusBar.Panels[STATUSBAR_PANEL_STATUS].Width := self.width - (
                                                        StatusBar.Panels[STATUSBAR_PANEL_SELECTEDITEMS].Width +
                                                        StatusBar.Panels[STATUSBAR_PANEL_LOCATION].Width
                                                       ); 
end;

procedure TfrmFreeOTFEExplorerMain.mntSelectAllClick(Sender: TObject);
begin
  SDFilesystemListView1.SelectAll();
  SDFilesystemListView1.SetFocus();
end;

procedure TfrmFreeOTFEExplorerMain.actRefreshExecute(Sender: TObject);
begin
  SetStatusMsg(_('Refreshing...'));
  SDFilesystemTreeView1.RefreshNodes();
  SetStatusMsg('');
end;

procedure TfrmFreeOTFEExplorerMain.CloseAnyMounted();
begin
  if (Filesystem <> nil) then
    begin
    Filesystem.Mounted := FALSE;
    Filesystem.Free();
    Filesystem := nil;
    end;

  if (PartitionImage <> nil) then
    begin
    PartitionImage.Mounted := FALSE;
    PartitionImage.Free();
    PartitionImage := nil
    end;

  SDFilesystemListView1.Filesystem := nil;
  SDFilesystemTreeView1.Filesystem := nil;

end;


procedure TfrmFreeOTFEExplorerMain.mntOpenImageFileClick(Sender: TObject);
begin
  if SDUOpenDialog_Mount.Execute() then
    begin
    MountImageFile(SDUOpenDialog_Mount.Filename, FALSE);
    end;
end;

procedure TfrmFreeOTFEExplorerMain.MountImageFile(filename: string; mountAsFreeOTFE: boolean);
begin
  CloseAnyMounted();

  if mountAsFreeOTFE then
    begin
    PartitionImage := TSDPartitionImage_FreeOTFE.Create();
    TSDPartitionImage_FreeOTFE(PartitionImage).FreeOTFEObj := OTFEFreeOTFEDLL1;
    TSDPartitionImage_FreeOTFE(PartitionImage).Filename := filename;
    PartitionImage.Mounted := TRUE;
    end
  else
    begin
    PartitionImage := TSDPartitionImage_File.Create();
    TSDPartitionImage_File(PartitionImage).Filename := filename;
    PartitionImage.Mounted := TRUE;
    end;

  if not(PartitionImage.Mounted) then
    begin
    PartitionImage.Free();
    PartitionImage := nil;
    end;

  if (PartitionImage <> nil) then
    begin
    Filesystem := TSDFilesystem_FAT.Create();
    Filesystem.PartitionImage := PartitionImage;
    try
      Filesystem.Mounted := TRUE;
    except
      on E:EFileSystemNotRecognised do
        begin
        SDUMessageDlg(_('The filesystem used by this volume could not be recognised as either FAT16 or FAT32.'), mtError);
        CloseAnyMounted();
        end;
    end;
    end;

  if (Filesystem <> nil) then
    begin
    if Filesystem.Mounted then
      begin
      SetupControls();
      SetTitleCaption(filename);
      end;
    end;

end;

procedure TfrmFreeOTFEExplorerMain.mnuAddressBarClick(Sender: TObject);
begin
  EnableDisableControls();
end;

procedure TfrmFreeOTFEExplorerMain.FormShow(Sender: TObject);
begin
  // Setup so *we* draw this panel, as we want the little image displayed
//  StatusBar.Panels[STATUSBAR_PANEL_LOCATION].Style := psOwnerDraw;

  SetTitleCaption('');
  SetStatusMsg();

  SDUCenterControl(lblFolder, ccVertical);
  SDUCenterControl(edPath, ccVertical);
  SDUCenterControl(pbGo, ccVertical);

  OTFEFreeOTFEDLL1.Active := TRUE;
  
  EnableDisableControls();
end;

procedure TfrmFreeOTFEExplorerMain.mntAboutClick(Sender: TObject);
var
  dlg: TSDUAboutDialog;
begin
  dlg := TSDUAboutDialog.Create(self);
  try
    dlg.BetaNumber := APP_BETA_BUILD;
    dlg.URL := FREEOTFE_URL;
    dlg.Description := FOTFE_EXPL_DESCRIPTION;
    dlg.ShowModal();
  finally
    dlg.Free();
  end;

end;

procedure TfrmFreeOTFEExplorerMain.mnuCheckFilesystemClick(Sender: TObject);
var
  allOK: boolean;
begin
  SetStatusMsg(_('Checking filesystem...'));
  try
    allOK := Filesystem.CheckFilesystem();
  finally
    SetStatusMsg('');
  end;

  if allOK then
    begin
    SDUMessageDlg(_('Filesystem OK'), mtInformation);
    end
  else
    begin
    Filesystem.Readonly := TRUE;
    SDUMessageDlg(
                  SDUParamSubstitute(
                                     _('Filesytem errors detected.'+SDUCRLF+
                                       SDUCRLF+
                                       'Please mount as a normal drive, and run chkdsk to correct.'+
                                       SDUCRLF+
                                       '%1 will continue in readonly mode'),
                                     [Application.Title]
                                    ),
                  mtError
                  );
    end;

end;

function TfrmFreeOTFEExplorerMain.DefaultStatusMsg(): string;
var
  fsFreeSpace: ULONGLONG;
//  fsSize: ULONGLONG;
  dispMsg: string;
  selectedItem: TSDDirItem;
  size: string;
  fileType: string;
  date: string;
  sizeKB: integer;
  itemsInSelected: integer;
begin
  // Fallback msg; anything other than ''
  dispMsg := _('Ready.');

  if (Filesystem = nil) then
    begin
    dispMsg := _('Ready to mount volume...');
    end
  else
    begin
    if (SDFilesystemListView1.SelCount <= 0) then
      begin
      fsFreeSpace := Filesystem.FreeSpace;
  //    fsSize := Filesystem.Size;

      itemsInSelected := SDFilesystemListView1.Items.Count;
      if SDFilesystemListView1.ShowParentDir then
        begin
        dec(itemsInSelected);
        end;

      dispMsg := SDUParamSubstitute(
                                    _('%1 objects (Disk free space: %2)'),
                                    [
                                     itemsInSelected,
  //                                   SDUFormatAsBytesUnits(fsFreeSpace),
                                     // MS Explorer only displays to 1 decimal place
                                     SDUFormatUnits(
                                                    fsFreeSpace,
                                                    SDUUnitsStorageToTextArr(),
                                                    UNITS_BYTES_MULTIPLIER,
                                                    1
                                                   )
                                    ]
                                   );


  {
      dispMsg := SDUParamSubstitute(
                                   _('Free Space: %1; Total size: %2'),
                                   [
  //                                  SDUFormatAsBytesUnits(fsFreeSpace),
                                    // MS Explorer only displays to 1 decimal place
                                    SDUFormatUnits(
                                                   fsFreeSpace,
                                                   SDUUnitsStorageToTextArr(),
                                                   UNITS_BYTES_MULTIPLIER,
                                                   1
                                                  ),
  //                                  SDUFormatAsBytesUnits(fsSize)
                                    // MS Explorer only displays to 1 decimal place
                                    SDUFormatUnits(
                                                   fsSize,
                                                   SDUUnitsStorageToTextArr(),
                                                   UNITS_BYTES_MULTIPLIER,
                                                   1
                                                  )
                                    ]
                                   );
  }
      end
    else if (SDFilesystemListView1.SelCount = 1) then
      begin
      selectedItem := SDFilesystemListView1.DirItem[SDFilesystemListView1.SelectedIdx];
      if selectedItem.IsFile then
        begin
        // Always display size in KB
        sizeKB := (selectedItem.Size div BYTES_IN_KILOBYTE);
        // Round up, like MS Explorer does...
        if ((selectedItem.Size mod BYTES_IN_KILOBYTE) > 0) then
          begin
          sizeKB := sizeKB + 1;
          end;
        // Format with thousands separator and KB units
        size := SDUIntToStrThousands(sizeKB) + ' ' + UNITS_STORAGE_KB;

        fileType := SDUGetFileType_Description(selectedItem.Filename);
        date := DateTimeToStr(TimeStampToDateTime(selectedItem.TimestampLastModified));

        dispMsg := SDUParamSubstitute(
                                      _('Type: %1 Date Modified: %2 Size: %3'),
                                      [
                                       fileType,
                                       date,
                                       size
                                      ]
                                     );
        end
      else
        begin
        dispMsg := SDUParamSubstitute(
                                      _('%1 object selected'),
                                      [SDFilesystemListView1.SelCount]
                                     );
        end;

      end
    else
      begin
      dispMsg := SDUPluralMsg(
                              SDFilesystemListView1.SelCount,
                              [
                               SDUParamSubstitute(
                                                  _('%1 object selected'),
                                                  [SDFilesystemListView1.SelCount]
                                                 ),
                               SDUParamSubstitute(
                                                  _('%1 objects selected'),
                                                  [SDFilesystemListView1.SelCount]
                                                 )
                              ]
                             );
      end;
    end;

  Result := dispMsg;
end;

function TfrmFreeOTFEExplorerMain.SelectedItemsStatusMsg(): string;
var
  currItem: TSDDirItem;
  totalSize: ULONGLONG;
  sumAllItems: boolean;
  i: integer;
  onlyDirsSelected: boolean;
  retval: string;
begin
  retval := '';

  // If the only things which are *selected* are directories, return blank
  // If one or more items are selected, return their sum total size
  // If nothing is selected, return the sum total size of all items

  sumAllItems := (SDFilesystemListView1.SelCount <= 0);

  totalSize := 0;
  onlyDirsSelected := TRUE;
  for i:=0 to (SDFilesystemListView1.Items.Count - 1) do
    begin
    currItem:= SDFilesystemListView1.DirItem[i];

    if (
        SDFilesystemListView1.Items[i].Selected and
        currItem.IsFile
       ) then
      begin
      onlyDirsSelected := FALSE;
      end;

    if (
        (
         SDFilesystemListView1.Items[i].Selected or
         sumAllItems
        ) and
        currItem.IsFile
       ) then
      begin
      totalSize := totalSize + currItem.Size;
      end;

    end;

  if (
      (SDFilesystemListView1.SelCount > 0) and
      onlyDirsSelected
     ) then
    begin
    // Do nothing - already set to ''
    end
  else
    begin
    retval := SDUFormatUnits(
                             totalSize,
                             SDUUnitsStorageToTextArr(),
                             UNITS_BYTES_MULTIPLIER,
                             2
                            );
    end;

  Result := retval;
end;

procedure TfrmFreeOTFEExplorerMain.SDFilesystemListView1SelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  SetStatusMsg();
end;

procedure TfrmFreeOTFEExplorerMain.SDFilesystemTreeView1Change(Sender: TObject;
  Node: TTreeNode);
begin
  edPath.text := SDFilesystemTreeView1.PathToNode(Node);
  SetStatusMsg();
end;

procedure TfrmFreeOTFEExplorerMain.FormResize(Sender: TObject);
begin
  SizeStatusBar();
end;

procedure TfrmFreeOTFEExplorerMain.StatusBarDrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
var
  textRect: TRect;
begin
  if (Panel.Index <> STATUSBAR_PANEL_LOCATION) then
    begin
    inherited;
    end
  else
    begin
    if (Panel.Text <> '') then
      begin
      ImageList_Small.Draw(StatusBar.Canvas, Rect.Left, Rect.Top, IMGLIST_IDX_FREEOTFE);

      textRect := Rect;
      textRect.Left := textRect.Left + ImageList_Small.width;

      // +2 here to give a bit of a gap between the image and text
      // +1 here so it's at the same height as the text in other panels
      StatusBar.Canvas.TextRect(
                                textRect,
                                (textRect.Left + 2),
                                (textRect.Top + 1),
                                Panel.Text
                               );
      end;
    end;
end;

procedure TfrmFreeOTFEExplorerMain.mnuViewStoreFileClick(Sender: TObject);
begin
  PromptForFileAndImport(SDFilesystemListView1.Path);
end;

procedure TfrmFreeOTFEExplorerMain.PromptForFileAndImport(importToPath: WideString);
var
  allOK: boolean;
  srcPathAndFilename: WideString;
  item: TSDDirItem_FAT;
  CreationTime: TFileTime;
  LastAccessTime: TFileTime;
  LastWriteTime: TFileTime;
  newDateTime: string;
begin
  allOK := TRUE;
  
  if allOK then
    begin
    allOK := SDUOpenDialog_Store.Execute;
    srcPathAndFilename := SDUOpenDialog_Store.Filename;
    end;

  if allOK then
    begin
    item:= TSDDirItem_FAT.Create();
    try
      if Filesystem.GetItem(
                 IncludeTrailingPathDelimiter(importToPath)+
                 ExtractFilename(srcPathAndFilename),
                 item
                ) then
        begin
        if item.IsDirectory then
          begin
          SDUMessageDlg(
                        SDUParamSubstitute(
                                           _('A directory called ''%1'' already exists'),
                                           [ExtractFilename(srcPathAndFilename)]
                                          ),
                        mtError
                       );
          allOK := FALSE;
          end
        else if item.IsFile then
          begin
          newDateTime:= '???';
          if SDUFileTimestamps(
                               srcPathAndFilename,
                               CreationTime,
                               LastAccessTime,
                               LastWriteTime
                              ) then
            begin
            newDateTime := DateTimeToStr(SDUFileTimeToDateTime(LastWriteTime));
            end;

          allOK := (SDUMessageDlg(
                                  SDUParamSubstitute(
                                            _('This folder already contains a file named ''%1''.'+SDUCRLF+
                                              SDUCRLF+
                                              'Would you like to replace the existing file'+SDUCRLF+
                                              SDUCRLF+
                                              '  %2'+SDUCRLF+
                                              '  modified: %3'+SDUCRLF+
                                              SDUCRLF+
                                              'with this one?'+SDUCRLF+
                                              SDUCRLF+
                                              '  %4'+SDUCRLF+
                                              '  modified: %5'),
                                           [
                                            ExtractFilename(srcPathAndFilename),
                                            SDUFormatAsBytesUnits(item.Size),
                                            DateTimeToStr(TimeStampToDateTime(item.TimestampLastModified)),
                                            SDUFormatAsBytesUnits(SDUGetFileSize(srcPathAndFilename)),
                                            newDateTime
                                           ]
                                          ),
                        mtConfirmation,
                        [mbYes, mbNo],
                        0) = mrYes);
          end;
        end;

    finally
      item.Free();
    end;

    end;

    if allOK then
    begin
      if StoreFile(SDFilesystemListView1.Path, srcPathAndFilename) then
        begin
        SDUMessageDlg(_('File stored successfully'), mtInformation);
        end
      else
        begin
        SDUMessageDlg(
                      _('Unable to store file'+SDUCRLF+
                        SDUCRLF+
                        'Please ensure that there is enough free space available'),
                      mtError
                     );
        end;

      // Refresh regardless
      actRefreshExecute(nil);
    end;

end;

function TfrmFreeOTFEExplorerMain.StoreFile(path: WideString; fileToStore: string): boolean;
var
  item: TSDDirItem_FAT;
  retval: boolean;
  fileStream: TFileStream;
  CreationTime: TFileTime;
  LastAccessTime: TFileTime;
  LastWriteTime: TFileTime;
  fileAttrs: integer;
begin
  item:= TSDDirItem_FAT.Create();
  fileStream := TFileStream.Create(fileToStore, (fmOpenRead or fmShareDenyNone));
  try
    item.Filename := ExtractFilename(fileToStore);
    item.FilenameDOS := '';  // Set to '' to autogenerate DOS 8.3 filename

    item.IsFile := TRUE;  // *VERY* IMPORTANT!!!

    item.Size := SDUGetFileSize(fileToStore);

    if SDUFileTimestamps(fileToStore, CreationTime, LastAccessTime, LastWriteTime) then
      begin
      item.TimestampCreation     := SDUFileTimeToTimeStamp(CreationTime);
      item.DatestampLastAccess   := SDUFileTimeToDateTime(LastAccessTime);
      item.TimestampLastModified := SDUFileTimeToTimeStamp(LastWriteTime);
      end
    else
      begin
      item.TimestampCreation     := DateTimeToTimeStamp(now);
      item.DatestampLastAccess   := Now;
      item.TimestampLastModified := DateTimeToTimeStamp(now);
      end;

// Turn off useless hints about FileCtrl.pas being platform specific
{$WARN SYMBOL_PLATFORM OFF}
{$WARN UNIT_PLATFORM OFF}
    fileAttrs:= FileGetAttr(fileToStore);
    if (fileAttrs <> -1) then
      begin
      item.IsReadonly := (fileAttrs and faReadOnly) = faReadOnly;
      item.IsArchive  := (fileAttrs and faArchive) = faArchive;
      item.IsHidden   := (fileAttrs and faHidden) = faHidden;
      item.IsSystem   := (fileAttrs and faSysFile) = faSysFile;
      end;
{$WARN UNIT_PLATFORM ON}
{$WARN SYMBOL_PLATFORM ON}

    retval := Filesystem.StoreFileOrDir(path, item, fileStream);
  finally
    fileStream.Free();
    item.Free();
  end;

  Result := retval;
end;

function TfrmFreeOTFEExplorerMain.StoreDir(path: WideString; dirToStore: string): boolean;
var
  allOK: boolean;
  fileIterator: TSDUFileIterator;
  nextItem: string;
  dirName: WideString;
  itemList: TSDDirItemList;
begin
  allOK := TRUE;

  dirName := ExtractFilename(dirToStore);

  // Sanity check
  if allOK then
    begin
    allOK := DirectoryExists(dirToStore);
    end;

  if allOK then
    begin
    allOK := CreateSubDir(Path, dirName);
    if not(allOK) then
      begin
      // If the directory couldn't be created - check to see if it already
      // exists. If it does, ignore the creation error
      itemList:= TSDDirItemList.Create();
      try
        allOK := Filesystem.LoadContentsFromDisk(
                                      IncludeTrailingPathDelimiter(Path)+dirName,
                                      itemList
                                     );
      finally
        itemList.Free();
      end;
      end;
    end;

  if allOK then
    begin
    fileIterator:= TSDUFileIterator.Create(nil);
    try
      fileIterator.Directory := dirToStore;
      fileIterator.IncludeDirNames := TRUE;
      fileIterator.RecurseSubDirs := FALSE;  // Recursion carried out by this function calling StoreDir(...)
      fileIterator.Reset();
      nextItem := fileIterator.Next();
      while (nextItem <> '') do
        begin
        if DirectoryExists(nextItem) then
          begin
          allOK := StoreDir(
                            IncludeTrailingPathDelimiter(Path)+dirName,
                            nextItem
                           );
          end
        else
          begin
          allOK := StoreFile(
                            IncludeTrailingPathDelimiter(Path)+dirName,
                            nextItem
                           );
          end;

        if not(allOK) then
          begin
          break;
          end;

        nextItem := fileIterator.Next();
        end;
    finally
      fileIterator.Free();
    end;
    end;

  Result := allOK;
end;

procedure TfrmFreeOTFEExplorerMain.PromptForDirAndImport(importToPath: WideString);
var
  allOK: boolean;
  srcPath: WideString;
  srcPathStr: string;
  item: TSDDirItem_FAT;
begin
  allOK := TRUE;

  if allOK then
    begin
    allOK := SDUSelectDirectory(
                                self.Handle,
                                _('Folder to store:'),
                                '',
                                srcPathStr
                               );
    srcPath := srcPathStr;
    end;


  if allOK then
    begin
    item:= TSDDirItem_FAT.Create();
    try
      if Filesystem.GetItem(
                 IncludeTrailingPathDelimiter(importToPath)+
                 ExtractFilename(srcPath),
                 item
                ) then
        begin
        if item.IsFile then
          begin
          SDUMessageDlg(
                        SDUParamSubstitute(
                                           _('A file called ''%1'' already exists'),
                                           [ExtractFilename(srcPath)]
                                          ),
                        mtError
                       );
          allOK := FALSE;
          end
        else if item.IsDirectory then
          begin
          allOK := (SDUMessageDlg(
                                  SDUParamSubstitute(
                                            _('This folder already contains a folder named ''%1''.'+SDUCRLF+
                                              SDUCRLF+
                                              'If the files in the existing folder have the same name as files in the folder you are moving or copying, they will be replaced. Do you will want to move or copy the folder?'),
                                           [ExtractFilename(srcPath)]
                                          ),
                        mtConfirmation,
                        [mbYes, mbNo],
                        0) = mrYes);
          end;
        end;

    finally
      item.Free();
    end;

    end;

    if allOK then
    begin
      if StoreDir(importToPath, srcPath) then
        begin
        SDUMessageDlg(_('Folder stored successfully'), mtInformation);
        end
      else
        begin
        SDUMessageDlg(_('Unable to store folder'+SDUCRLF+
                        SDUCRLF+
                        'Please ensure that there is enough free space available'),
                      mtError);
        end;

      // Refresh regardless
      actRefreshExecute(nil);
    end;

end;


procedure TfrmFreeOTFEExplorerMain.mnuViewStoreDirClick(Sender: TObject);
begin
  PromptForDirAndImport(SDFilesystemListView1.Path);
end;


procedure TfrmFreeOTFEExplorerMain.mnuViewDeleteClick(Sender: TObject);
var
  userConfirmed: boolean;
  promptMsg: WideString;
  item: TSDDirItem;
  i: integer;
  allOK: boolean;
begin
  userConfirmed := FALSE;

  if (SDFilesystemListView1.SelCount = 0) then
    begin
    // Do nothing; userConfirmed already set to FALSE
    end
  else
    begin
    if (SDFilesystemListView1.SelCount = 1) then
      begin
      item := SDFilesystemListView1.DirItemSelected;
      if item.IsFile then
        begin
        promptMsg := SDUParamSubstitute(
                                        _('Are you sure you want to delete ''%1''?'),
                                        [item.Filename]
                                       );
        end
      else
        begin
        promptMsg := SDUParamSubstitute(
                                        _('Are you sure you want to remove the folder ''%1'' and all its contents?'),
                                        [item.Filename]
                                       );
        end;

      end
    else
      begin
      promptMsg := SDUParamSubstitute(
                                      _('Are you sure you want to delete these %1 items?'),
                                      [SDFilesystemListView1.SelCount]
                                     );
      end;

    userConfirmed := (SDUMessageDlg(
                                    promptMsg,
                                    mtConfirmation,
                                    [mbYes, mbNo],
                                    0
                                   ) = mrYes);
    end;

  if userConfirmed then
    begin
    allOK := TRUE;
    for i:=0 to (SDFilesystemListView1.Items.count - 1) do
      begin
      if SDFilesystemListView1.Items[i].Selected then
        begin
        allOK := Filesystem.DeleteFileOrDir(
                                 IncludeTrailingPathDelimiter(SDFilesystemListView1.Path)+SDFilesystemListView1.DirItem[i].Filename
                                 );
        if not(allOK) then
          begin
          SDUMessageDlg(
                        SDUParamSubstitute(
                                           // Note: Windows Explorer states "files" here,
                                           //       even if it's a dir, so we do as well
                                           _('Cannot delete ''%1'': Cannot find the specified file.'+SDUCRLF+
                                             SDUCRLF+
                                             'Make sure you specify the correct path and file name.'),
                                            [SDFilesystemListView1.DirItem[i].Filename]
                                          ),
                                          mtError
                                         );
          break;
          end;
        end;
      end;

      if allOK then
        begin
        SDUMessageDlg(_('Deleted successfully'), mtInformation);
        end;

      // Refresh anyway, in case *some* but not all files were deleted
      actRefreshExecute(Sender);
    end;

end;

function TfrmFreeOTFEExplorerMain.CreateSubDir(path: WideString; newDirName: WideString): boolean;
begin
  Result := Filesystem.CreateDir(path, newDirName);
end;

procedure TfrmFreeOTFEExplorerMain.mnuViewCreateSubDirClick(Sender: TObject);
var
  retval: boolean;
  dlg: TNewDirDialog;
begin
  dlg := TNewDirDialog.Create(self);
  try
    if (dlg.ShowModal() = mrOK) then
      begin
      retval := CreateSubDir(
                             SDFilesystemListView1.Path,
                             dlg.DirName
                            );

      if retval then
        begin
        SDUMessageDlg(_('Folder created successfully'), mtInformation);
        end
      else
        begin
        SDUMessageDlg(_('Unable to create folder'+SDUCRLF+
                        SDUCRLF+
                        'Please ensure that there is enough free space available'),
                      mtError);
        end;

      actRefreshExecute(Sender);
      end;
      
  finally
    dlg.Free();
  end;
  
end;

procedure TfrmFreeOTFEExplorerMain.actFreeOTFEMountFileExecute(Sender: TObject);
begin
  if OTFEFreeOTFEDLL1.WarnIfNoHashOrCypherDrivers() then
    begin
    SDUOpenSaveDialogSetup(SDUOpenDialog_Mount, '');

    SDUOpenDialog_Mount.Filter     := FILE_FILTER_FLT_VOLUMES;
    SDUOpenDialog_Mount.DefaultExt := FILE_FILTER_DFLT_VOLUMES;

    if SDUOpenDialog_Mount.Execute() then
      begin
      MountImageFile(SDUOpenDialog_Mount.Filename, TRUE);
      end;
    end;

end;

END.


